<?php

namespace Soisy\PaymentMethod\Observer;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Exception\LocalizedException;
use Soisy\PaymentMethod\Helper\Settings;

class ZeroRateOrderPlaceBefore implements ObserverInterface
{
    /**
     * @var Settings
     */
    protected $settings;

    public function __construct(
        Settings $settings
    ){
        $this->settings = $settings;
    }
    public function execute(Observer $observer)
    {
        $order = $observer->getEvent()->getOrder();

        $zeroRateConfiguration = $this->settings->getZeroRateConfiguration();
        $zeroRateItemConfiguration = $this->settings->getZeroRateItemConfiguration();
        if($zeroRateConfiguration == Settings::SOISY_ZERO_RATE_ITEM_CONF &&
            !is_null($zeroRateItemConfiguration) &&
            $zeroRateItemConfiguration == Settings::SOISY_ZERO_RATE_ITEM_FIX_CODE)
        {
            $checkQuoteItem = $this->settings->checkQuoteItemForZeroRate($order->getItems(), $zeroRateItemConfiguration, $order->getStoreId(), true);
            if(!$checkQuoteItem) {
                throw new LocalizedException(__('All products in the cart must have zero rate'));
            }
        }
    }
}